clear all
clc;
ITER_MAX = 100000;
dim = 4;
% for i=1:ITER_MAX
%     a = rand;
%     b = 1-a;
%     eta = rand(dim,1);
%     lambda = rand(dim,1);
%     eta1 = eta/sum(2*eta);
%     lambda1 = lambda/sum(2*lambda);
%     gamma1 = eta1.*lambda1;
%     eta = rand(dim,1);
%     lambda = rand(dim,1);
%     eta2 = eta/sum(2*eta);
%     lambda2 = lambda/sum(2*lambda);
%     gamma2= eta2.*lambda2;
%     mid_eta = (a*eta1+b*eta2);
%     mid_lambda = (a*lambda1+b*lambda2);
%     mid_gamma = mid_eta.*mid_lambda;
%     hm1 = harmmean(gamma1);
%     hm2 = harmmean(gamma2);
%     hm3 = harmmean(mid_gamma);
%     if (a*hm1+b*hm2 > hm3)
%         'non-convex'
%         keyboard;
%     end
% end

eta_dim = 4;
lambda_dim = 2^(eta_dim-1)+1;
count = 0;
max_diff = 0;
for i=1:ITER_MAX
    a = rand;
    b = 1-a;
    eta = rand(eta_dim,1);
    eta1 = eta/sum(eta);
    lambda = rand(lambda_dim,1);
    normalizer(9,1) = lambda(9);
    normalizer([5,8],1) = lambda(5)+lambda(8);
    normalizer([3,7],1) = lambda(3)+lambda(7);
    normalizer([1,2,4,6],1) = lambda(1)+lambda(2)+lambda(4)+lambda(6);
    lambda1 = lambda./normalizer;
    gamma1 = ones( 2^(eta_dim-1)+1,1);
    gamma1(1) = eta1(1).*lambda1(1);
    gamma1(2:3,1) = eta1(2).*lambda1(2:3,1);
    gamma1(4:5,1) = eta1(3).*lambda1(4:5,1);
    gamma1(6:9,1) = eta1(4).*lambda1(6:9,1);

    eta = rand(eta_dim,1);
    eta2 = eta/sum(eta);
    lambda = rand(lambda_dim,1);
    normalizer(9,1) = lambda(9);
    normalizer([5,8],1) = lambda(5)+lambda(8);
    normalizer([3,7],1) = lambda(3)+lambda(7);
    normalizer([1,2,4,6],1) = lambda(1)+lambda(2)+lambda(4)+lambda(6);
    lambda2 = lambda./normalizer;
    gamma2 = ones( 2^(eta_dim-1)+1,1);
    gamma2(1) = eta2(1).*lambda2(1);
    gamma2(2:3,1) = eta2(2).*lambda2(2:3,1);
    gamma2(4:5,1) = eta2(3).*lambda2(4:5,1);
    gamma2(6:9,1) = eta2(4).*lambda2(6:9,1);

    mid_eta = (a*eta1+b*eta2);
    mid_lambda = (a*lambda1+b*lambda2);
    mid_gamma = ones( 2^(eta_dim-1)+1,1);
    mid_gamma(1) = mid_eta(1).*mid_lambda(1);
    mid_gamma(2:3,1) = mid_eta(2).*mid_lambda(2:3,1);
    mid_gamma(4:5,1) = mid_eta(3).*mid_lambda(4:5,1);
    mid_gamma(6:9,1) = mid_eta(4).*mid_lambda(6:9,1);
    
    f1 = harmmean(gamma1(1))+harmmean(gamma1(2:3,1))+harmmean(gamma1(4:5,1))+harmmean(gamma1(6:9,1));
    f2 = harmmean(gamma2(1))+harmmean(gamma2(2:3,1))+harmmean(gamma2(4:5,1))+harmmean(gamma2(6:9,1));
    f3 = harmmean(mid_gamma(1))+harmmean(mid_gamma(2:3,1))+harmmean(mid_gamma(4:5,1))+harmmean(mid_gamma(6:9,1));
    if (a*f1+b*f2 > f3)
        fprintf('Gap: %f\n',(a*f1+b*f2-f3)/f3);
        if (max_diff < (a*f1+b*f2-f3)/f3)
            max_diff = (a*f1+b*f2-f3)/f3;
        end
        count = count+1;
%         keyboard;
    end
end

